<template>
  <div>
    <ObForm
      class="add-field-form"
      :ref="formRefName"
      :form-data="formData"
      :form-model="formModel"
      @submit="onSumbit"
      @cancel="parentModalClose"
    >
      <div class="row">
        <div class="col-xs-6">
          <div class="row__title">
            Все возможные поля
          </div>
          <ObTable
                  ref="availabelFields"
                  data-grid-ref-name="availabelFields"
                  :columns="columns"
                  :page-limit="1000"
                  :items="fieldList"
                  group-by="group"
          >
            <div slot="actionRowSlot" slot-scope="{ data }">
              <div @click.stop.prevent="addField(data.item)" class="action-icon">
                <svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                  <path d="M15.1621 9.19048C15.1629 8.77059 15.6496 8.53856 15.9762 8.80235L19.6642 11.7802C19.9133 11.9813 19.9118 12.3614 19.6612 12.5606L15.9627 15.5003C15.6348 15.761 15.1509 15.5269 15.1516 15.108L15.1551 13.1465L5.14978 13.1465C4.5975 13.1465 4.14978 12.6988 4.14978 12.1465C4.14978 11.5942 4.5975 11.1465 5.14978 11.1465L15.1587 11.1465L15.1621 9.19048Z" fill="#9DA0AC"/>
                </svg>
              </div>
            </div>
            <div slot="footer">
              <div class="data-grid-totals">
                Количество записей: {{ fieldList.length }}
              </div>
            </div>
          </ObTable>
        </div>
        <div class="col-xs-6">
          <div class="row__title">
            Добавляемые поля
          </div>
          <ObTable
            ref="addedFieldsGrid"
            data-grid-ref-name="addedFieldsGrid"
            :columns="columns"
            :items="addedFields"
            :page-limit="1000"
            group-by="group"
          >
            <div slot="actionRowSlot" slot-scope="{ data }">
              <template v-if="isReqiredField(data.item)">
                <span style="font-size: 12px; line-height: 12px; letter-spacing: 0.4px; color: #9DA0AC; white-space: nowrap;">
                  Обязательное поле
                </span>
              </template>
              <template v-else>
                <div @click.stop.prevent="removeField(data.item)" class="action-icon">
                  <svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <path d="M8.83736 9.19048C8.83662 8.77059 8.34994 8.53856 8.02325 8.80235L4.3353 11.7802C4.08623 11.9813 4.08769 12.3614 4.3383 12.5606L8.03676 15.5003C8.36471 15.761 8.84862 15.5269 8.84787 15.108L8.84439 13.1465L18.8497 13.1465C19.402 13.1465 19.8497 12.6988 19.8497 12.1465C19.8497 11.5942 19.402 11.1465 18.8497 11.1465L8.84084 11.1465L8.83736 9.19048Z" fill="#9DA0AC"/>
                  </svg>
                </div>
              </template>
            </div>
            <div slot="footer">
              <div class="data-grid-totals">
                Количество записей: {{ addedFields.length }}
              </div>
            </div>
          </ObTable>
        </div>
      </div>
    </ObForm>
  </div>
</template>

<script>
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import ObTable from 'common-components/src/obComponents/obTable'
import ObForm from 'common-components/src/obComponents/obForm'
import models from '../../../models'
import api from '@/api'

export default {
  name: "modalFieldAdd",
  props: {
    disabledForm: Boolean,
  },
  components: {
    ObForm,
    ObTable
  },
  mixins: [
    FormValidationMixin
  ],
  data () {
    return {
      fieldList: [],
      addedFields: []
    }
  },
  mounted () {
    this.fetchFields()
  },
  computed: {
    formModel () {
      return models.cardFields.add
    },
    columns () {
      return [
        {
          title: '',
          key: 'title'
        },
        {
          title: '',
          width: 150,
          slotName: 'actionRowSlot'
        }
      ]
    },
    filteredFieldsList () {
      return this.fieldList.filter((item) => {
        return !this.addedFields.length || Boolean(this.addedFields.find(field => field.uuid !== item.uuid))
      })
    }
  },
  methods: {
    async addField (data) {
      this.addedFields.push(data)
      this.fieldList = this.fieldList.filter(item => item.uuid !== data.uuid)
    },
    async removeField (data) {
      this.addedFields = this.addedFields.filter(item => item.uuid !== data.uuid)
      this.fieldList.push(data)
    },
    async onSumbit () {
      let notificationId = new Date().getTime()+'save';
      try {
        this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});

        await api.card.update(this.formData)
        this.$emit('save')
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      } finally {
        this.$notification({event: 'close', id: notificationId})
      }
    }
    ,
    async fetchFields () {
      try {
        this.addedFields = this.processFields(await api.card.fetch())
        this.fieldList = this.processFields(await api.card.availableFields())
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },
    processFields (fields) {
      return fields.map((item) => {
        return {
          ...item,
          group: item.RequisiteGroupsDto && item.RequisiteGroupsDto.requisite_group_title || null
        }
      })
    },
    isReqiredField (data) {
      return data && (data.code || data.is_key_part || data.need_for_registration)
    }
  },
  watch: {
    'parentModal.visible' (value) {
      if (value) {
        this.fetchFields()
      }
    },
    addedFields () {
      this.formData.field_uuids = this.addedFields.map(item => item.uuid)
    }
  }
};
</script>

<style lang="scss">
  .add-field-form {
    .row {
      .ob-table-inner {
        &.tb_showMore:before {
          display: none;
        }
      }
      &__title {
        margin-bottom: 16px;
        font-size: 12px;
        line-height: 16px;
        text-transform: uppercase;
        color: $organizationsCardConfiguratorPage-add_field_form_row_title;
      }
      table {
        min-width: auto;
      }
      thead {
        display: none;
        & + .data-row {
          border-top: none!important;
        }
      }
      .action-icon {
        display: flex;
        justify-content: flex-end;
        align-items: center;
        cursor: pointer;
        &:hover {
          opacity: 0.6;
        }
        &:active {
          transform: scale(0.9);
        }
      }

      .ob-table-inner {
        height: 500px;
        border: 1px solid $lavender;
        border-radius: 3px;
      }

      .table-empty {
        display: none;
      }

      .table-panel-inner {
        .table-empty {
          display: block;
        }
      }

      .table-footer {
        flex-shrink: 0;
      }
    }
  }
</style>
